# daytona_api_client
Daytona Workspaces API Docs

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 0.12.0
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import daytona_api_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import daytona_api_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import daytona_api_client
from daytona_api_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = daytona_api_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

configuration.access_token = os.environ["ACCESS_TOKEN"]


# Enter a context with an instance of the API client
with daytona_api_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = daytona_api_client.ApiKeysApi(api_client)
    create_api_key = daytona_api_client.CreateApiKey() # CreateApiKey | 

    try:
        # Create API key
        api_response = api_instance.create_api_key(create_api_key)
        print("The response of ApiKeysApi->create_api_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ApiKeysApi->create_api_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ApiKeysApi* | [**create_api_key**](docs/ApiKeysApi.md#create_api_key) | **POST** /api-keys | Create API key
*ApiKeysApi* | [**delete_api_key**](docs/ApiKeysApi.md#delete_api_key) | **DELETE** /api-keys/{name} | Delete API key
*ApiKeysApi* | [**get_api_key**](docs/ApiKeysApi.md#get_api_key) | **GET** /api-keys/{name} | Get API key
*ApiKeysApi* | [**list_api_keys**](docs/ApiKeysApi.md#list_api_keys) | **GET** /api-keys | List API keys
*DockerRegistryApi* | [**create_registry**](docs/DockerRegistryApi.md#create_registry) | **POST** /docker-registry | Create registry
*DockerRegistryApi* | [**delete_registry**](docs/DockerRegistryApi.md#delete_registry) | **DELETE** /docker-registry/{id} | Delete registry
*DockerRegistryApi* | [**get_registry**](docs/DockerRegistryApi.md#get_registry) | **GET** /docker-registry/{id} | Get registry
*DockerRegistryApi* | [**list_registries**](docs/DockerRegistryApi.md#list_registries) | **GET** /docker-registry | List registries
*DockerRegistryApi* | [**set_default_registry**](docs/DockerRegistryApi.md#set_default_registry) | **POST** /docker-registry/{id}/set-default | Set default registry
*DockerRegistryApi* | [**update_registry**](docs/DockerRegistryApi.md#update_registry) | **PATCH** /docker-registry/{id} | Update registry
*ImagesApi* | [**create_image**](docs/ImagesApi.md#create_image) | **POST** /images | Create a new image
*ImagesApi* | [**get_all_images**](docs/ImagesApi.md#get_all_images) | **GET** /images | List all images
*ImagesApi* | [**remove_image**](docs/ImagesApi.md#remove_image) | **DELETE** /images/{id} | Delete image
*ImagesApi* | [**toggle_image_state**](docs/ImagesApi.md#toggle_image_state) | **PATCH** /images/{id}/toggle | Toggle image state
*NodesApi* | [**create_node**](docs/NodesApi.md#create_node) | **POST** /nodes | Create node
*NodesApi* | [**list_nodes**](docs/NodesApi.md#list_nodes) | **GET** /nodes | List all nodes
*NodesApi* | [**update_node_scheduling**](docs/NodesApi.md#update_node_scheduling) | **PATCH** /nodes/{id}/scheduling | Update node scheduling status
*ToolboxApi* | [**create_folder**](docs/ToolboxApi.md#create_folder) | **POST** /toolbox/{workspaceId}/toolbox/files/folder | Create folder
*ToolboxApi* | [**create_session**](docs/ToolboxApi.md#create_session) | **POST** /toolbox/{workspaceId}/toolbox/process/session | Create session
*ToolboxApi* | [**delete_file**](docs/ToolboxApi.md#delete_file) | **DELETE** /toolbox/{workspaceId}/toolbox/files | Delete file
*ToolboxApi* | [**delete_session**](docs/ToolboxApi.md#delete_session) | **DELETE** /toolbox/{workspaceId}/toolbox/process/session/{sessionId} | Delete session
*ToolboxApi* | [**download_file**](docs/ToolboxApi.md#download_file) | **GET** /toolbox/{workspaceId}/toolbox/files/download | Download file
*ToolboxApi* | [**execute_command**](docs/ToolboxApi.md#execute_command) | **POST** /toolbox/{workspaceId}/toolbox/process/execute | Execute command
*ToolboxApi* | [**execute_session_command**](docs/ToolboxApi.md#execute_session_command) | **POST** /toolbox/{workspaceId}/toolbox/process/session/{sessionId}/exec | Execute command in session
*ToolboxApi* | [**find_in_files**](docs/ToolboxApi.md#find_in_files) | **GET** /toolbox/{workspaceId}/toolbox/files/find | Search for text/pattern in files
*ToolboxApi* | [**get_file_info**](docs/ToolboxApi.md#get_file_info) | **GET** /toolbox/{workspaceId}/toolbox/files/info | Get file info
*ToolboxApi* | [**get_project_dir**](docs/ToolboxApi.md#get_project_dir) | **GET** /toolbox/{workspaceId}/toolbox/project-dir | Get workspace project dir
*ToolboxApi* | [**get_session**](docs/ToolboxApi.md#get_session) | **GET** /toolbox/{workspaceId}/toolbox/process/session/{sessionId} | Get session
*ToolboxApi* | [**get_session_command**](docs/ToolboxApi.md#get_session_command) | **GET** /toolbox/{workspaceId}/toolbox/process/session/{sessionId}/command/{commandId} | Get session command
*ToolboxApi* | [**get_session_command_logs**](docs/ToolboxApi.md#get_session_command_logs) | **GET** /toolbox/{workspaceId}/toolbox/process/session/{sessionId}/command/{commandId}/logs | Get command logs
*ToolboxApi* | [**git_add_files**](docs/ToolboxApi.md#git_add_files) | **POST** /toolbox/{workspaceId}/toolbox/git/add | Add files
*ToolboxApi* | [**git_clone_repository**](docs/ToolboxApi.md#git_clone_repository) | **POST** /toolbox/{workspaceId}/toolbox/git/clone | Clone repository
*ToolboxApi* | [**git_commit_changes**](docs/ToolboxApi.md#git_commit_changes) | **POST** /toolbox/{workspaceId}/toolbox/git/commit | Commit changes
*ToolboxApi* | [**git_create_branch**](docs/ToolboxApi.md#git_create_branch) | **POST** /toolbox/{workspaceId}/toolbox/git/branches | Create branch
*ToolboxApi* | [**git_get_history**](docs/ToolboxApi.md#git_get_history) | **GET** /toolbox/{workspaceId}/toolbox/git/history | Get commit history
*ToolboxApi* | [**git_get_status**](docs/ToolboxApi.md#git_get_status) | **GET** /toolbox/{workspaceId}/toolbox/git/status | Get git status
*ToolboxApi* | [**git_list_branches**](docs/ToolboxApi.md#git_list_branches) | **GET** /toolbox/{workspaceId}/toolbox/git/branches | Get branch list
*ToolboxApi* | [**git_pull_changes**](docs/ToolboxApi.md#git_pull_changes) | **POST** /toolbox/{workspaceId}/toolbox/git/pull | Pull changes
*ToolboxApi* | [**git_push_changes**](docs/ToolboxApi.md#git_push_changes) | **POST** /toolbox/{workspaceId}/toolbox/git/push | Push changes
*ToolboxApi* | [**list_files**](docs/ToolboxApi.md#list_files) | **GET** /toolbox/{workspaceId}/toolbox/files | List files
*ToolboxApi* | [**list_sessions**](docs/ToolboxApi.md#list_sessions) | **GET** /toolbox/{workspaceId}/toolbox/process/session | List sessions
*ToolboxApi* | [**lsp_completions**](docs/ToolboxApi.md#lsp_completions) | **POST** /toolbox/{workspaceId}/toolbox/lsp/completions | Get Lsp Completions
*ToolboxApi* | [**lsp_did_close**](docs/ToolboxApi.md#lsp_did_close) | **POST** /toolbox/{workspaceId}/toolbox/lsp/did-close | Call Lsp DidClose
*ToolboxApi* | [**lsp_did_open**](docs/ToolboxApi.md#lsp_did_open) | **POST** /toolbox/{workspaceId}/toolbox/lsp/did-open | Call Lsp DidOpen
*ToolboxApi* | [**lsp_document_symbols**](docs/ToolboxApi.md#lsp_document_symbols) | **GET** /toolbox/{workspaceId}/toolbox/lsp/document-symbols | Call Lsp DocumentSymbols
*ToolboxApi* | [**lsp_start**](docs/ToolboxApi.md#lsp_start) | **POST** /toolbox/{workspaceId}/toolbox/lsp/start | Start Lsp server
*ToolboxApi* | [**lsp_stop**](docs/ToolboxApi.md#lsp_stop) | **POST** /toolbox/{workspaceId}/toolbox/lsp/stop | Stop Lsp server
*ToolboxApi* | [**lsp_workspace_symbols**](docs/ToolboxApi.md#lsp_workspace_symbols) | **GET** /toolbox/{workspaceId}/toolbox/lsp/workspace-symbols | Call Lsp WorkspaceSymbols
*ToolboxApi* | [**move_file**](docs/ToolboxApi.md#move_file) | **POST** /toolbox/{workspaceId}/toolbox/files/move | Move file
*ToolboxApi* | [**replace_in_files**](docs/ToolboxApi.md#replace_in_files) | **POST** /toolbox/{workspaceId}/toolbox/files/replace | Replace in files
*ToolboxApi* | [**search_files**](docs/ToolboxApi.md#search_files) | **GET** /toolbox/{workspaceId}/toolbox/files/search | Search files
*ToolboxApi* | [**set_file_permissions**](docs/ToolboxApi.md#set_file_permissions) | **POST** /toolbox/{workspaceId}/toolbox/files/permissions | Set file permissions
*ToolboxApi* | [**upload_file**](docs/ToolboxApi.md#upload_file) | **POST** /toolbox/{workspaceId}/toolbox/files/upload | Upload file
*UsersApi* | [**create_user**](docs/UsersApi.md#create_user) | **POST** /users | Create user
*UsersApi* | [**get_user_usage_overview**](docs/UsersApi.md#get_user_usage_overview) | **GET** /users/overview | Get user current usage overview
*UsersApi* | [**list_users**](docs/UsersApi.md#list_users) | **GET** /users | List all users
*UsersApi* | [**regenerate_key_pair**](docs/UsersApi.md#regenerate_key_pair) | **POST** /users/{id}/regenerate-key-pair | Regenerate user key pair
*WorkspaceApi* | [**create_snapshot**](docs/WorkspaceApi.md#create_snapshot) | **POST** /workspace/{workspaceId}/snapshot | Create workspace snapshot
*WorkspaceApi* | [**create_workspace**](docs/WorkspaceApi.md#create_workspace) | **POST** /workspace | Create a new workspace
*WorkspaceApi* | [**delete_workspace**](docs/WorkspaceApi.md#delete_workspace) | **DELETE** /workspace/{workspaceId} | Delete workspace
*WorkspaceApi* | [**get_workspace**](docs/WorkspaceApi.md#get_workspace) | **GET** /workspace/{workspaceId} | Get workspace details
*WorkspaceApi* | [**list_workspaces**](docs/WorkspaceApi.md#list_workspaces) | **GET** /workspace | List all workspaces
*WorkspaceApi* | [**replace_labels**](docs/WorkspaceApi.md#replace_labels) | **PUT** /workspace/{workspaceId}/labels | Replace workspace labels
*WorkspaceApi* | [**start_workspace**](docs/WorkspaceApi.md#start_workspace) | **POST** /workspace/{workspaceId}/start | Start workspace
*WorkspaceApi* | [**stop_workspace**](docs/WorkspaceApi.md#stop_workspace) | **POST** /workspace/{workspaceId}/stop | Stop workspace
*WorkspaceApi* | [**update_public_status**](docs/WorkspaceApi.md#update_public_status) | **POST** /workspace/{workspaceId}/public/{isPublic} | Update public status
*WorkspaceApi* | [**workspace_controller_resize_workspace**](docs/WorkspaceApi.md#workspace_controller_resize_workspace) | **POST** /workspace/{workspaceId}/resize | 


## Documentation For Models

 - [ApiKeyList](docs/ApiKeyList.md)
 - [ApiKeyResponse](docs/ApiKeyResponse.md)
 - [Command](docs/Command.md)
 - [CompletionContext](docs/CompletionContext.md)
 - [CompletionItem](docs/CompletionItem.md)
 - [CompletionList](docs/CompletionList.md)
 - [CreateApiKey](docs/CreateApiKey.md)
 - [CreateDockerRegistry](docs/CreateDockerRegistry.md)
 - [CreateImage](docs/CreateImage.md)
 - [CreateNode](docs/CreateNode.md)
 - [CreateSessionRequest](docs/CreateSessionRequest.md)
 - [CreateUser](docs/CreateUser.md)
 - [CreateWorkspace](docs/CreateWorkspace.md)
 - [DockerRegistry](docs/DockerRegistry.md)
 - [ExecuteRequest](docs/ExecuteRequest.md)
 - [ExecuteResponse](docs/ExecuteResponse.md)
 - [FileInfo](docs/FileInfo.md)
 - [FileStatus](docs/FileStatus.md)
 - [GitAddRequest](docs/GitAddRequest.md)
 - [GitBranchRequest](docs/GitBranchRequest.md)
 - [GitCloneRequest](docs/GitCloneRequest.md)
 - [GitCommitInfo](docs/GitCommitInfo.md)
 - [GitCommitRequest](docs/GitCommitRequest.md)
 - [GitCommitResponse](docs/GitCommitResponse.md)
 - [GitRepoRequest](docs/GitRepoRequest.md)
 - [GitStatus](docs/GitStatus.md)
 - [ImageDto](docs/ImageDto.md)
 - [ListBranchResponse](docs/ListBranchResponse.md)
 - [LspCompletionParams](docs/LspCompletionParams.md)
 - [LspDocumentRequest](docs/LspDocumentRequest.md)
 - [LspLocation](docs/LspLocation.md)
 - [LspServerRequest](docs/LspServerRequest.md)
 - [LspSymbol](docs/LspSymbol.md)
 - [Match](docs/Match.md)
 - [PaginatedImagesDto](docs/PaginatedImagesDto.md)
 - [Position](docs/Position.md)
 - [ProjectDirResponse](docs/ProjectDirResponse.md)
 - [Range](docs/Range.md)
 - [ReplaceRequest](docs/ReplaceRequest.md)
 - [ReplaceResult](docs/ReplaceResult.md)
 - [SearchFilesResponse](docs/SearchFilesResponse.md)
 - [Session](docs/Session.md)
 - [SessionExecuteRequest](docs/SessionExecuteRequest.md)
 - [SessionExecuteResponse](docs/SessionExecuteResponse.md)
 - [ToggleState](docs/ToggleState.md)
 - [UpdateDockerRegistry](docs/UpdateDockerRegistry.md)
 - [UsageOverview](docs/UsageOverview.md)
 - [Workspace](docs/Workspace.md)
 - [WorkspaceInfo](docs/WorkspaceInfo.md)
 - [WorkspaceLabels](docs/WorkspaceLabels.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="oauth2"></a>
### oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://bbox.us.auth0.com/authorize
- **Scopes**: 
 - **openid**: OpenID
 - **profile**: Profile
 - **email**: Email
 - **https://api.blinkbox.dev**: API access
 - **read:roles**: Read user roles


## Author




